; I used Turbo Assembler 4.1 to compile this.
; tasm /m2 mokcod
; tlink mokcod /t
; Frenkel_Smeijers@hotmail.com
; http://www.sfprod.cjb.net

.8086
code segment
jumps
locals
assume cs:code,ds:nothing,ss:nothing

org 100h

begin:

mov ah,9                           ;-\
mov dx, offset CodeText$           ;  > Print CodeText$
int 21h                            ;-/

mov cx, -1
CodeLoop:
  add cx, 101h

  cmp cl,1
  jnz Not1
    mov cl,19
  Not1:
  cmp cl,20
  jnz Not20
    mov cl,1
  Not20:
  cmp cl,10
  jnz Not10
    inc cl
  Not10:
  cmp cl,13
  jnz Not13
    inc cl
  Not13:

  mov ah,9                          ;-\
  mov dx,offset Level$              ;  > Print Level$
  int 21h                           ;-/

  mov al,ch                         ;-\
  xor ah,ah                         ; |
  aaa                               ;  > DX = ASCII values for CH
  add ax,3030h                      ; |
  mov dx,ax                         ;-/

cmp ch, 16
jne Anders
mov dx, 3136h

Anders:
  mov ah,2                          ;-\
  xchg dl,dh                        ;  > Print 1st digit
  int 21h                           ;-/

  xchg dl,dh                        ; \  Print 2nd digit
  int 21h                           ;-/

  mov dl,':'                        ; \  Print colon
  int 21h                           ;-/
  mov dl,' '                        ; \  Print space
  int 21h                           ;-/

  call GetCode

  mov bx,cx
    mov cx,4
PrintCode:
    rol ax,4
    push ax
      and al,0Fh                     ;-\
      daa                            ;  \ Change lower 4 bits of AX into it's
      add al,-10h                    ;  / ASCII value
      adc al,'0'+10h                 ;-/
   
      mov ah,2                       ;-\
      mov dl,al                      ;  > Print digit
      int 21h                        ;-/
    pop ax
    loop PrintCode
  mov cx,bx

  mov ah,2                          ;-\
  mov dl,13                         ; |
  int 21h                           ;  \ Advance to next line
  mov ah,2                          ;  /
  mov dl,10                         ; |
  int 21h                           ;-/

  cmp ch,16
jb CodeLoop



mov ah,9                           ;-\
mov dx,offset Credits$             ;  > Print the Credits$ string
int 21h                            ;-/

xor ah,ah                          ;-\ Wait for a key
int 16h                            ;-/

mov ah,4ch                         ;-\ Exit
int 21h                            ;-/


GetCode proc                       ; Convert levelnumber in CL to code in AX
  mov bl, cl
  xor bh, bh

  mov dx, cx

  mov ax, 0f000h
  mov es, ax

  mov si, 0fff0h
  mov ax, es:[bx]

  mov cl, 3
  xor ch, ch
  xor al, bl
  sub ah, bl
  ror ax, cl

BIOSDATE:
  xor ax, es:[si]
  inc si
  inc si
  loop BIOSDATE
  mov cl, bl
  rol ax, cl      ;ax = code
  
  mov cx, dx

  ret
GetCode endp



CodeText$ db 13,10,'Moktar level codes:',13,10,'$'
Level$ db ' Etape $'
Credits$ db 13,10,'Moktar Code Generator by Frenkel with help from Jesse, 2004',13,10,'$'

code ends
end begin
